//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxTextEdit"
#pragma link "Chart"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma link "Series"
#pragma resource "*.dfm"

TForm3 *Form3;

//---------------------------------------------------------------------------

__fastcall TForm3::TForm3(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm3::Button4Click(TObject *Sender)
{
    Chart1->MarginUnits = muPixels;
    Chart1->View3D = false;


    ClearChartObjects();

    for (int i = 0; i < 10; ++i)
        CreateChartSeries(i);

    ConnectSeriesWithAxes();
}

//---------------------------------------------------------------------------

void TForm3::ClearChartObjects() const
{
    for (int i = Chart1->SeriesCount() - 1; i >= 0; i--)
    {
        TChartSeries *series = Chart1->Series[i];

        series->Clear();
        series->SetFunction(0);
        Chart1->RemoveSeries(series);

        delete series;
    }

    Chart1->CustomAxes->Clear();
}

//---------------------------------------------------------------------------

void TForm3::CreateChartSeries(int index) const
{
    TChartSeries *series = 0;

    TLineSeries* lineSeries = new TLineSeries(Chart1);
    series = lineSeries;

    series->XValues->DateTime = true;
    series->XValues->Order = loNone;
    series->Cursor = crCross;

    Chart1->AddSeries(series);
}

//---------------------------------------------------------------------------

void TForm3::ConnectSeriesWithAxes()
{
    const int mcAxisSpacing = 12;

    int mLeftChartMargin = 0;


    for (int i = 0; i < 10; i++)
    {
        TChartAxis* customAxis = (TChartAxis*)Chart1->CustomAxes->Add();

        customAxis->SetMinMax(0, i*100 + 100);
        customAxis->AdjustMaxMin();


        TChartSeries *series = Chart1->Series[i];
        series->CustomVertAxis = customAxis;


        // ERROR for serieses that has maximum equal to 300, 400, 800, 900 MaxLabelsWidth returns 9 instead of 21
        //int ml = customAxis->MaxLabelsWidth();

        int maxLabelsWidth = customAxis->MaxLabelsWidth() + customAxis->TickLength;;
        int axisRegionWidth = int(maxLabelsWidth + mcAxisSpacing);

        customAxis->PositionUnits = muPixels;
        customAxis->PositionPercent = -mLeftChartMargin;

        mLeftChartMargin += axisRegionWidth;
    }

    Chart1->MarginLeft = mLeftChartMargin;
}

//---------------------------------------------------------------------------
